<script setup lang="ts">
import { useEmployeeStore } from '@/stores/employee'
import type { User } from '@/types/User'
import { ref, nextTick, computed, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'
import http from '@/service/http'
import { useLoadingStore } from '@/stores/loading'
import employeeService from '@/service/employee'
import { useUserStore } from '@/stores/user'
import { useRoleStore } from '@/stores/role'
import { useBranchStore } from '@/stores/branch'
import type { Branch } from '@/types/Branch'
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const userStore = useUserStore()
const roleStore = useRoleStore()
const loadingStore = useLoadingStore()
const page = ref(1)
const itemsPerPage = ref<any>(5)
const search = ref<string>('')
const branchStore = useBranchStore()

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Image',
    key: 'image',
    value: 'image'
  },
  {
    title: 'Name',
    key: 'fullName',
    value: 'fullName'
  },
  {
    title: 'Gender',
    key: 'gender'
  },
  {
    title: 'BankAccount',
    key: 'bankAcc',
    value: 'bankAcc'
  },
  {
    title: 'Role',
    key: 'roles',
    value: (item: any | User) => item.roles.map((r: any) => r.name).join(',')
  },
  {
    title: 'Branch',
    key: 'branch',
    value: (item: User) => {
      if (item.branch) return item.branch.name
      else {
        return ''
      }
    }
  },
  { title: '', key: 'actions', sortable: false }
]

let editedIndex = -1

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}

async function deleteItemConfirm() {
  closeDelete()
  // console.log(Employees.value)
  await userStore.deleteUser()
}

const pageCount = computed(() => {
  return Math.ceil(userStore.users.length / itemsPerPage.value)
})

async function deleteItem(item: User) {
  await userStore.getUser(item.id)
  dialogDelete.value = true
  editedIndex = -1
}

async function editItem(employee: User) {
  console.log(employee)
  await userStore.getUser(employee.id)
  dialog.value = true
}

onMounted(async () => {
  //ดึงข้อมูลจาก backend
  await userStore.getUsers()
  await roleStore.getRoles()
  await branchStore.getBranchs()
})

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    userStore.clearForm()
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  closeDialog()
  console.log(userStore.editedUser.tel)
  await userStore.saveUser()
}

const formattedEmployees = computed(() => userStore.users.map((User) => ({ ...User })))

const filteredEmployees = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedEmployees.value.filter((Employee) =>
    Employee.fullName.toLowerCase().includes(searchLower)
  )
})
onMounted(() => {
  userStore.getUsers()
  console.log(userStore.users)
})
</script>

<template>
  <div>
    <div class="ml-5">
      <!-- Data -->
      <div class="text-center">
        <h1 style="text-align: left">
          <v-icon icon="mdi mdi-account" class="mr-2"></v-icon>Employee
        </h1>
      </div>
      <br />

      <v-row
        ><v-col cols="6">
          <!-- search -->
          <v-text-field
            v-model="search"
            prepend-inner-icon="mdi-magnify"
            density="compact"
            label="Search"
            single-line
            flat
            hide-details
            variant="solo-filled"
          ></v-text-field
        ></v-col>

        <v-col>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <div>
                <v-btn color="success" style="background-color: rgb(139, 82, 38)" v-bind="props">
                  <v-icon icon="mdi mdi-account-plus" size="25px" class="mr-2"></v-icon>
                  <div style="text-align: left">New Employee</div>
                </v-btn>
              </div>
            </template>
            <v-card title="Employee Profile" class="pt-6" style="text-align: center">
              <v-card-title color="blue"
                ><v-card-text>
                  <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="userStore.editedUser.fullName"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Name"
                            placeholder="Enter your name"
                            variant="outlined"
                          ></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="userStore.editedUser.tel"
                            :readonly="loading"
                            :rules="[
                              (v) => !!v || 'Field is Field is required',
                              (v) => (v && v.length === 10) || 'Tel. number must be 10 digits',
                              (v) => /^\d+$/.test(v) || 'Tel. number must contain only digits'
                            ]"
                            class="mb-2"
                            clearable
                            label="Tel."
                            placeholder="Enter your tel."
                            variant="outlined"
                          ></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="userStore.editedUser.email"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            clearable
                            label="Email"
                            placeholder="Enter your email"
                            variant="outlined"
                          ></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="userStore.editedUser.password"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            clearable
                            label="Password"
                            placeholder="Enter your password"
                            variant="outlined"
                          ></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="userStore.editedUser.bankAcc"
                            :readonly="loading"
                            :rules="[
                              (v) => !!v || 'Field is Field is required',
                              (v) =>
                                (v && v.length === 10) || 'Bank Account number must be 10 digits',
                              (v) =>
                                /^\d+$/.test(v) || 'Bank Account number must contain only digits'
                            ]"
                            class="mb-2"
                            clearable
                            label="Bank Account"
                            placeholder="Enter your bank account"
                            variant="outlined"
                          ></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="6">
                          <v-combobox
                            v-model="userStore.editedUser.roles"
                            :items="roleStore.roles"
                            item-title="name"
                            item-value="id"
                            label="Select roles"
                            multiple
                            :return-object="true"
                          ></v-combobox>
                        </v-col>

                        <v-col cols="12" sm="6">
                          <v-combobox
                            label="Gender"
                            :items="['Male', 'Female', 'Others']"
                            v-model="userStore.editedUser.gender"
                            variant="outlined"
                          ></v-combobox>
                        </v-col>

                        <v-col cols="12" sm="6">
                          <v-combobox
                            v-model="userStore.editedUser.branch"
                            :items="branchStore.branchs"
                            label="Select your branch"
                            :return-object="true"
                            item-title="name"
                            item-value="id"
                            variant="outlined"
                          ></v-combobox>
                        </v-col>

                        <v-col cols="12" sm="12" md="6">
                          <v-file-input
                            v-model="userStore.editedUser.files"
                            variant="outlined"
                            :rules="[
                              (value) => {
                                return (
                                  !value ||
                                  !value.length ||
                                  value[0].size < 2000000 ||
                                  'Image size should be less than 2 MB!'
                                )
                              }
                            ]"
                            accept="image/png, image/jpeg, image/bmp"
                            label="Image"
                            placeholder="Pick an avatar"
                            prepend-icon="mdi-camera"
                          ></v-file-input>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-form> </v-card-text
              ></v-card-title>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  style="width: 200px; height: 60px"
                  variant="flat"
                  @click="closeDialog()"
                  class="ms-5"
                  color="red"
                  >Cancel</v-btn
                >
                <v-btn
                  style="width: 200px; height: 60px"
                  variant="flat"
                  color="success"
                  @click="save()"
                  class="ms-10"
                >
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-col></v-row
      >

      <div>
        <!-- new employee -->
        <div>
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="font ma-4 pt-6" style="text-align: center"
                >you want to delete this info? 🗑️</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  color="red"
                  variant="flat"
                  style="width: 150px; height: 50px"
                  class="mb-3"
                  @click="closeDelete"
                  >Cancel</v-btn
                >
                <v-spacer></v-spacer>
                <v-btn
                  color="success"
                  variant="flat"
                  style="width: 150px; height: 50px"
                  class="mb-3"
                  @click="deleteItemConfirm"
                  >OK</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </div>

        <!-- table -->
        <div>
          <v-data-table
            v-model:page="page"
            :headers="headers"
            :items="userStore.users"
            :items-per-page="itemsPerPage"
          >
            <template v-slot:bottom>
              <div class="text-center pt-2">
                <v-pagination v-model="page" :length="pageCount"></v-pagination>
              </div>
            </template>
            <template v-slot:[`item.image`]="{ item }">
              <v-img
                :src="'http://localhost:3000/images/users/' + item.image"
                width="100"
                height="100"
              ></v-img>
            </template>
            <!-- <template v-slot:item.actions="{ item }"> -->
            <template v-slot:[`item.actions`]="{ item }">
              <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
              <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
            </template>
            <template v-slot:no-data>
              <v-btn color="primary" @click="userStore.getUsers()">Reset</v-btn>
            </template>
          </v-data-table>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped>
.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}

/* .v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: Verdana, sans-serif;
} */

div {
  font-family: 'Kanit';
}
</style>
